C++ 抛出和接收异常的顺序

代码编译运行环境:VS2017+Debug+Win32


异常(exception)是 C++ 引入的错误处理机制。它采用了统一的方式对程序的运行时错误进行处理,具有标准化、安全和高效的特点。C++ 为了实现异常处理,引入了三个关键字 try、throw、catch。异常由 throw 抛出,格式为 throw [expression],由catch 捕捉。try 语句块是可能抛出异常的语句块,它通常和一个或多个 catch 语句块连续出现。

try 语句块和 catch 语句块必须相互配合,以下三种情况都会导致编译错误:
(1)只有 try 语句块而没有 catch 语句块,或者只有 catch 语句块而没有 try 语句块;
(2)在 try 语句块和 catch 语句块之间夹杂其他语句;
(3)当 try 语句块后跟多个 catch 语句块时,catch 语句块之间夹杂其他语句;
(4)同一种数据类型的传值 catch 分支与传引用 catch 分支不能同时出现。

在抛出和接收异常的过程中,我们还要注意以下几点。

1.被抛出的异常对象什么时候被销毁?

用 throw 语句抛出一个对象时,会构造一个新的对象,这个对象就是异常对象。该对象的生命周期从被抛出开始计算,一直到被某个 catch 语句捕捉,就会在该 catch 语句块执行完毕后被销毁。考察如下程序。

#include <iostream>
using namespace std;

class ExClass {
	int num;
public:
	ExClass(int i) {
		cout<<"Constructing exception object with num="<<i<<endl;
		num=i;
	}
	ExClass(ExClass& e) {
		cout<<"Copy Constructing exception object with num="<<e.num+1<<endl;
		num=e.num+1;
	}
	~ExClass() {
		cout<<"Destructing exception object with num="<<num<<endl;
	}
	void show() {
		cout<<"the number is "<<num<<endl;
	}
};

int main() {
	ExClass obj(99);
	try {
		throw obj;     // 导致输出:Copy Constructing exception object with num=100
	}
	catch(double f) {
		cout<<"exception catched"<<endl;
	}
	// 导致输出:Constructing exception object with num=101
	catch(ExClass e) {
		e.show();
	}
	cout<<"after catch"<<endl;
}

程序输出结果是:

Constructing exception object with num=99
Copy Constructing exception object with num=100
Copy Constructing exception object with num=101
the number is 101
Destructing exception object with num=101
Destructing exception object with num=100
after catch
Destructing exception object with num=99

用 throw 语句抛出一个对象时,会构造一个新的对象,这个对象就是异常对象。该对象的生命周期从被抛出时开始计算,一直到被某个 catch 语句捕获,就会在该 catch 语句块执行完毕后被销毁。在上面的程序中,异常对象的 num 值为 100,“Destructing exception object with num=100” 这句话在 “after catch” 之前输出,正好说明异常对象的销毁时间是在它被捕获的 catch 块执行之后。

所有的 catch 分支在执行时类似一次函数调用,catch 的参数相当于函数的形参,而被抛出的异常对象相当于函数调用时的实参。当形参与实参成功匹配时,就说明异常被某个 catch 分支捕获。catch 后面的参数只能采用传值、传引用和传指针三种方式,如果采用传值方式,则会生成实参的一个副本,如果实参是一个对象,就会导致构造函数被调用。在上面的程序中,执行 catch(ExClass e) 语句就是利用异常对象构造一个对象 e,因此会调用拷贝构造函数。

注意:同一种数据类型的传值 catch 分支和传引用 catch 分支不能同时出现。

2.异常如果在当前函数没有被捕获会发生什么?

在某些情况下,可能所有的 catch 分支都无法捕获到抛出的异常,这将导致当前函数执行结束并返回到主调函数中。在主调函数中,将继续以上捕捉异常的过程,直到异常被捕捉或最终结束整个程序。

#include <iostream>
using namespace std;

class ExClass {
	int num;
public:
	ExClass(int i) {
		cout<<"Constructing exception object with num="<<i<<endl;
		num=i;
	}
	ExClass(ExClass& e) {
		cout<<"Copy  Constructing exception object with num="<<e.num+1<<endl;
		num=e.num+1;
	}
	~ExClass() {
		cout<<"Destructing exception object with num="<<num<<endl;
	}
	void show() {
		cout<<"the number is "<<num<<endl;
	}
};

void throwExFunc() {
	try {
		throw ExClass(199);
	}
	catch(double f) {
		cout<<"double exception catched"<<endl;
	}
	cout<<"exit throwExFunc()"<<endl;
}

int main() {
	try {
		throwExFunc();
	}
	catch(ExClass e) {
		e.show();
	}
	catch(...) {
		cout<<"all will fall in"<<endl;
	}
	cout<<"continue to execute"<<endl;
}

程序的输出结果:

Constructing exception object with num=199
Copy Constructing exception object with num=200
the number is 200
Destructing exception object with num=200
Destructing exception object with num=199
continue to execute

从程序的结果可以看出:
(1)被抛出的异常对象的 num 值为 199,由于它没有在函数 throwExFunc() 中被捕捉,所以它导致了 throwExFunc() 的执行结束,否则会输出 exit throwExFunc()。在 main() 函数中,catch(ExClass e) 捕获了异常对象,通过复制构造函数产生对象 e,e 的num 值为 200,catch 语句块运行完结束后,对象 e 首先被销毁,紧接着销毁异常对象。在这之后,程序继续运行,输出:continue to execute。

(2)catch(…) 的意思是可以捕获所有类型的异常。不提倡随意地使用 catch(…),因为这会导致不精确处理异常类型,并降低程序的运行效率。但是,在程序的开发阶段,catch(…) 还是有用的,因为如果在精心安排异常捕获之后,还是进入了 catch(…) 语句块,说明前面的代码存在缺陷,需要进一步改正。

(3)在捕捉异常对象时,还可以采用传引用的方式,例如把 catch 语句写成 catch(ExClass& e),这样可以不必产生异常对象的副本,减少程序的运行开销,提高运行效率。

(4)在抛出异常时,还可以抛出一个指针。当然这种做法比较危险。如果要确保安全,应该将指针指向全局(静态)对象或动态申请的空间,或者被抛出的指针在本函数内被捕获。否则,利用一个被抛出的指向已经被销毁的对象指针很危险。如果实在要用,首先,必须保证对象的析构函数不能对对象的内容作破坏性修改。其次,对象的空间没有被其他新产生的变量覆盖。也就说,尽管对象被释放,但它的有效内容依然保留在栈中。


参考文献

[1] 陈刚.C++高级进阶教程[M].武汉:武汉大学出版社,2008.P365-368

©️2020 CSDN 皮肤主题: 编程工作室 设计师:CSDN官方博客 返回首页